<template>
  <view class="page-aggregating-order">
    <view class="header">
      <view class="left">
        <u-icon class="icon" name="arrow-left" @click="uni.navigateBack()" />
      </view>
      <view class="title">辅料交接</view>
      <view class="right"></view>
    </view>
    <view class="table-wrapper">
      <wyb-table
        class="table"
        ref="table"
        width="100%"
        show-left-and-right-border
        enable-check="multiple"
        :headers="headers"
        :contents="model.accessoryList"
        :show-vert-border="false"
        @onCheck="onCheck"
      ></wyb-table>
    </view>
    <view class="bottom-bar">
      <view class="extra">
        <u-form ref="amountForm" :model="amountForm" :error-type="['toast']">
          <u-row class="bottom-info">
            <u-col :span="12">
              <u-form-item prop="amount" label="数量" label-width="120rpx">
                <u-input type="number" v-model="amountForm.amount" />
              </u-form-item>
            </u-col>
          </u-row>
        </u-form>
        <u-form ref="submitForm" :model="submitForm" :error-type="['toast']">
          <u-row class="bottom-info">
            <u-col :span="6">
              <u-form-item prop="receiverName" label="接收人" label-width="120rpx">
                <u-input v-model="submitForm.receiverName" @confirm="onReceiverConfirm" />
              </u-form-item>
            </u-col>
            <u-col :span="6">
              <u-form-item prop="password" label="口令">
                <u-input type="number" v-model="submitForm.password" />
              </u-form-item>
            </u-col>
          </u-row>
        </u-form>
      </view>
      <view class="container">
        <u-row>
          <u-col :span="4">
            <u-button type="warning" @click="onSelectAll"> 全选 </u-button>
          </u-col>
          <u-col :span="4">
            <u-button type="primary" @click="onOk"> 确认 </u-button>
          </u-col>
          <u-col :span="4">
            <u-button type="success" @click="onSubmit"> 上传 </u-button>
          </u-col>
        </u-row>
      </view>
    </view>
  </view>
</template>

<script lang="ts">
import { Component, Ref } from 'vue-property-decorator';
import { BasePage } from '@/components/base/page';
import model from './model';
import { summaryHeaders } from './config';
import { VForm, VFormRules } from 'vue/types/form';
import { auth } from '@/store/modules/auth';
import { pick } from 'lodash/fp';
import http from '@/utils/request';
import { url } from '@/utils/url';
import { session } from '@/store/modules/session';

@Component
export default class AggregatingSummary extends BasePage {
  /**
   * 表格引用
   */
  @Ref('table') readonly $table: any;

  /**
   * 表单引用
   */
  @Ref('amountForm') readonly $amountForm!: VForm;
  @Ref('submitForm') readonly $submitForm!: VForm;

  /**
   * 页面Module
   */
  model = model;

  /**
   * 表头
   */
  headers = summaryHeaders;

  /**
   * 交接完成
   */
  isHandoverFinished = true;

  /**
   * 更改数量表单
   */
  amountForm = {
    amount: '',
  };

  /**
   * 上传表单
   */
  submitForm = {
    receiver: '',
    receiverName: '',
    password: '',
  };

  amountFormRules: VFormRules<any> = {
    amount: [{ required: true, message: '请输入数量！' }],
  };

  submitFormRules: VFormRules<any> = {
    receiver: [{ required: true, message: '请输入接收人' }],
    password: [{ required: true, message: '请输入口令' }],
  };

  // 必须要在onReady生命周期，因为onLoad生命周期组件可能尚未创建完毕
  onReady() {
    this.$amountForm.setRules(this.amountFormRules);
    this.$submitForm.setRules(this.submitFormRules);
    this.isHandoverFinished = false;
  }

  beforeDestroy() {
    if (model.accessoryList.length > 0 && !this.isHandoverFinished) {
      this.unlock();
    }
  }

  /**
   * 处理选择行
   */
  onCheck(e: any) {
    e.data.forEach((line: any) => {
      const { index, lineData: item } = line;
      const hvAmount = item.totalMoAmount - item.totalHvAmount;
      model.setAccessoryListItemHvAmount({ index, hvAmount });
    });
  }

  /**
   * 全选
   */
  onSelectAll() {
    this.$table.onCheckAllTap();
  }

  /**
   * 接收人确认
   */
  async onReceiverConfirm() {
    const userInfo = await auth.getUserInfo({
      loginName: this.submitForm.receiver,
    });
    this.submitForm.receiver = this.submitForm.receiverName;
    this.submitForm.receiver = userInfo.userName;
  }

  /**
   * 确认
   */
  onOk() {
    this.$amountForm.validate((valid) => {
      if (!valid) return;
      const firstSelection = this.model.accessoryList.find((_) => _.checked);
      if (firstSelection === undefined) {
        uni.showToast({ icon: 'none', title: '请选中要修改的行！' });
      } else {
        // 本次交接数量
        const currentPickNum = parseFloat(this.amountForm.amount);
        // 已交接数量
        const totalHvAmount = parseFloat(firstSelection.totalHvAmount);
        // 拣配数量
        const totalMoAmount = parseFloat(firstSelection.totalMoAmount);
        if (currentPickNum + totalHvAmount - totalMoAmount > 0.000001) {
          uni.showToast({ icon: 'none', title: '本次交接数量+交接数量不允许大于拣配数量！' });
        } else if (currentPickNum <= 0) {
          uni.showToast({ icon: 'none', title: '本次交接数量应为大于0的数！' });
        } else {
          model.setAccessoryListItemHvAmount({
            index: this.model.accessoryList.findIndex((_) => _.checked),
            hvAmount: currentPickNum,
          });
        }
      }
    });
  }

  /**
   * 上传
   */
  onSubmit() {
    this.$submitForm.validate(async (valid) => {
      if (valid) {
        if (model.accessoryList.length === 0) {
          uni.showToast({ icon: 'none', title: '没有可用上传的数据！' });
        } else {
          await auth.checkPassword({
            rfPwd: this.submitForm.password,
            factoryCode: session.factoryCode as string,
            loginName: this.submitForm.receiver,
          });
          await model.uploadAccessoryList({
            operatorPass: this.submitForm.password,
            factoryCode: session.factoryCode,
            loginName: session.loginName,
            dataList: model.accessoryList.map((item) => ({
              ...pick(
                [
                  'materialCode',
                  'sapFactoryCode',
                  'materialDesc',
                  'unit',
                  'wkposCode',
                  'mrpCode',
                  'sendSpot',
                  'serialNo',
                ],
                item,
              ),
              amount: String(item.amount),
              hvAmount: String(item.hvAmount),
              totalMoAmount: String(item.totalMoAmount),
              totalHvAmount: String(item.totalHvAmount),
              prdMaterialDesc: String(item.prdMaterialCode),
            })),
            includeOrderOutIdList: model.proOrderResultList.map((item: any) => item.orderOutId),
          });
          this.submitForm.receiver = '';
          this.submitForm.receiverName = '';
          this.submitForm.password = '';
          // uni.navigateBack({ delta: 1 });
          model.clearProOrderResultList();
          setTimeout(() => {
            uni.navigateBack({ delta: 1 });
          }, 2000);
        }
      }
    });
  }

  /**
   * 解锁
   */
  async unlock() {
    const orderOutIdList = model.proOrderResultList.map((_: any) => _.orderOutId);
    try {
      await http.post(url.sumscan.unlock.list, {
        factoryCode: session.factoryCode,
        loginName: session.loginName,
        orderOutIdList,
      });
    } catch (e) {
      uni.showToast({ icon: 'none', title: '解锁失败，详情：' + e.message });
    }
  }
}
</script>

<style lang="scss" scoped>
.page-aggregating-order {
  background: #f2f2f2 linear-gradient(0deg, #f2f2f2 0%, #4a78ea 51%, #1753ea 100%) no-repeat;
  background-size: 100% 600rpx;
  padding: 30rpx;
  min-height: 100%;
  padding-top: 118rpx;
  padding-bottom: 280rpx;

  .header {
    position: fixed;
    top: 36rpx;
    left: 0;
    right: 0;
    display: flex;
    height: 88rpx;
    line-height: 88rpx;
    color: #fff;
    font-size: 34rpx;
    font-weight: 500;
    text-align: center;
    .title {
      flex: 3;
    }
    .left,
    .right {
      flex: 1;
    }
    .icon {
      display: flex;
      justify-content: center;
      align-items: center;
      width: 88rpx;
      height: 88rpx;
    }
  }

  .table-wrapper {
    background-color: #fff;
  }

  .form {
    background-color: #fff;
    padding: 40rpx;
    border-radius: 10rpx;
  }

  .bottom-bar {
    z-index: 21;
    position: fixed;
    bottom: 0;
    left: 0;
    right: 0;

    .container {
      background: #ffffff;
      box-shadow: 0 1rpx 20rpx 0 rgba(128, 128, 128, 0.2);
      padding: 20rpx;
    }

    .extra {
      background-color: #fff;
      margin: 5px;
      border-radius: 5px;
      padding: 0 10px;
    }

    .bottom-info {
      .u-form-item {
        padding: 0;
      }
    }
  }
}
</style>
